<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.mediator.switchm.SwitchCaseMediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="java.util.regex.Pattern" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<fmt:bundle basename="org.wso2.carbon.mediator.switch.ui.i18n.Resources">
    <carbon:jsi18n
		resourceBundle="org.wso2.carbon.mediator.switch.ui.i18n.JSResources"
		request="<%=request%>"
        i18nObjectName="casei18n" />
    <%
        Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
        if (!(mediator instanceof SwitchCaseMediator)) {
            // todo : proper error handling
            throw new RuntimeException("Unable to edit the mediator");
        }

        SwitchCaseMediator switchCaseMediator = (SwitchCaseMediator)mediator;
        Pattern pattern = switchCaseMediator.getRegex();
        String caseValueString = "";
        if (pattern != null) {
            caseValueString = pattern.toString();
        }
    %>

    <div>
        <script type="text/javascript">
            function switchCaseMediatorValidate() {
                var caseValue = document.getElementById('caseValue').value;
                if (caseValue == null || caseValue == "") {
                    CARBON.showErrorDialog(casei18n['must.specify.caseValue']);
                    return false;
                }
                return true;
            }
        </script>
        <table class="normal" width="100%">
            <tr>
                <td>
                    <h2><fmt:message key="case.mediator"/></h2>
                </td>
            </tr>
            <tr>
                <td>
                    <table class="normal">
                        <tr>
                            <td>
                                <fmt:message key="case.value"/> <span class="required">*</span>
                            </td>
                            <td>
                                <input type="text" value="<%=caseValueString%>" id="caseValue" name="caseValue" size="40"/>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
    </div>
</fmt:bundle>
