    <%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.mediator.command.CommandMediator" %>
<%@ page import="org.apache.synapse.util.xpath.SynapseXPath" %>
<%@ page import="org.jaxen.JaxenException" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>

<%
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof CommandMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }
    CommandMediator pojoCommandMediator = (CommandMediator) mediator;
    String propName = null;
    String valueID = null;
    String newReadInfo = null;
    String newUpdateInfo = null;
    String readInfoSelect = null;
    String updateInfoSelect = null;
    SynapseXPath xPath;


    pojoCommandMediator.getContextGetterProperties().clear(); // to avoid duplicates
    pojoCommandMediator.getContextSetterProperties().clear();
    pojoCommandMediator.getMessageGetterProperties().clear();
    pojoCommandMediator.getMessageSetterProperties().clear();
    pojoCommandMediator.getStaticSetterProperties().clear();

    String propertyCountParameter = request.getParameter("propertyCount");
    if (propertyCountParameter != null && !"".equals(propertyCountParameter)) {
        int propertyCount = Integer.parseInt(propertyCountParameter.trim());
        for (int i = 0; i < propertyCount; i++) {
            valueID = "propertyName" + i;
            propName = request.getParameter(valueID);
            valueID = "propertySelectReadType" + i;
            readInfoSelect = request.getParameter(valueID);
            valueID = "readInfo" + i;
            newReadInfo = request.getParameter(valueID);

            // readInfo
            if (newReadInfo != null && readInfoSelect != null) {
                if (readInfoSelect.equals("value")) {
                    pojoCommandMediator.addStaticSetterProperty(propName, newReadInfo);
                } else if (readInfoSelect.equals("message")) {
                    try {
                        xPath = new SynapseXPath(newReadInfo);
                    } catch (JaxenException e) {
                        throw new Exception("Can not create XPath expression"); // TODO proper error handling
                    }
                    pojoCommandMediator.addMessageSetterProperty(propName, xPath);
                } else if (readInfoSelect.equals("context")) {
                    pojoCommandMediator.addContextSetterProperty(propName, newReadInfo);
                } else {
                    // should never comes here
                    throw new Exception("Invalid selection");
                }
            }

            // updateInfo
            valueID = "propertySelectUpdateType" + i;
            updateInfoSelect = request.getParameter(valueID);
            valueID = "updateInfo" + i;
            newUpdateInfo = request.getParameter(valueID);
            if(updateInfoSelect!=null && newUpdateInfo!=null){
                if(updateInfoSelect.equals("message")){
                    try {
                        xPath = new SynapseXPath(newUpdateInfo);
                    } catch (JaxenException e) {
                        throw  new Exception("Can not create XPath expression");
                    }
                    pojoCommandMediator.addMessageGetterProperty(propName, xPath);
                }else if(updateInfoSelect.equals("context")){
                    pojoCommandMediator.addContextGetterProperty(propName, newUpdateInfo);
                }
            }
        }
    }
%>








