<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.mediator.rule.RuleMediator" %>
<%@ page import="org.wso2.rule.description.RuleConfiguration" %>
<%@ page import="org.wso2.rule.RuleConstants" %>
<%@ page import="org.wso2.rule.description.ResourceDescription" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="org.apache.axiom.om.xpath.AXIOMXPath" %>
<%@ page import="org.jaxen.BaseXPath" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.ns.NameSpacesRegistrar" %>
<%@ page import="org.wso2.carbon.mediator.rule.ui.internal.RuleMediatorClientHelper" %>
<%@ page import="org.wso2.rule.description.PropertyDescription" %>
<%@ page import="java.util.Map" %>
<%@ page import="java.util.HashMap" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<fmt:bundle basename="org.wso2.carbon.mediator.rule.ui.i18n.Resources">
<carbon:jsi18n
        resourceBundle="org.wso2.carbon.mediator.rule.ui.i18n.JSResources"
        request="<%=request%>" i18nObjectName="rulejsi18n"/>

<%
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof RuleMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }
    RuleMediator ruleMediator = (RuleMediator) mediator;
    RuleConfiguration configuration = ruleMediator.getRuleConfiguration();
    String key = configuration != null && configuration.getRuleScriptKey() != null ?
            configuration.getRuleScriptKey() : "";
    String format = configuration != null && configuration.getSourceFormat() != null ?
            configuration.getSourceFormat() : "";
    Iterator<ResourceDescription> inputs = configuration != null ?
            configuration.getInputResourceDescriptions() :
            new ArrayList<ResourceDescription>().iterator();
    Iterator<ResourceDescription> outputs = configuration != null ?
            configuration.getOutPutResourceDescriptions() :
            new ArrayList<ResourceDescription>().iterator();
    String uri = configuration != null && configuration.getProviderUri() != null ?
            configuration.getProviderUri() : "";
    String providerClass = configuration != null && configuration.getProviderClass() != null ?
            configuration.getProviderClass() : "";
    String inputTableStyle = !inputs.hasNext() ? "display:none;" : "";
    String outputTableStyle = !outputs.hasNext() ? "display:none;" : "";
    NameSpacesRegistrar nameSpacesRegistrar = NameSpacesRegistrar.getInstance();
    Iterator<PropertyDescription> providerIterator = configuration != null ?
            configuration.getAllRuleExecutionSetProviderProperties() :
            new ArrayList<PropertyDescription>().iterator();
    RuleMediatorClientHelper.registerNameSpaces(providerIterator,"providerpropertyValue",session);
    Iterator<PropertyDescription> rulesessionIterator = configuration != null ?
            configuration.getAllRuleSessionProperties() :
            new ArrayList<PropertyDescription>().iterator();
    RuleMediatorClientHelper.registerNameSpaces(rulesessionIterator,"rulesessionpropertyValue",session);
    Iterator<PropertyDescription> creationIterator = configuration != null ?
            configuration.getAllRuleExecutionSetCreationProperties() :
            new ArrayList<PropertyDescription>().iterator();
    RuleMediatorClientHelper.registerNameSpaces(creationIterator,"creationpropertyValue",session);
    Iterator<PropertyDescription> registrationIterator = configuration != null ?
            configuration.getAllRuleExecutionSetRegistrationProperties() :
            new ArrayList<PropertyDescription>().iterator();
    RuleMediatorClientHelper.registerNameSpaces(registrationIterator,"registrationpropertyValue",session);
    Iterator<PropertyDescription> deRegistrationIterator = configuration != null ?
            configuration.getAllRuleExecutionSetDeregistrationProperties() :
            new ArrayList<PropertyDescription>().iterator();
    RuleMediatorClientHelper.registerNameSpaces(deRegistrationIterator,"deregistrationpropertyValue",session);
    String sessionString = configuration != null && configuration.getRuleSession() != null ?
            configuration.getRuleSession() : "";

    boolean isInlined = (key == null || "".equals(key));
    String inlinedScript = configuration != null && configuration.getRuleScript() != null ?
            configuration.getRuleScript().toString() : "";
    String policyID = SequenceEditorHelper.getEditingMediatorPosition(session) + "_rulescript";
    Map policyXMLMap = (Map) request.getSession().getAttribute("rulemediator_script_map");
    if (policyXMLMap == null) {
        policyXMLMap = new HashMap();
        request.getSession().setAttribute("rulemediator_script_map", policyXMLMap);
    }
    policyXMLMap.put(policyID, inlinedScript);

%>

<div>
<script type="text/javascript" src="../rule-mediator/js/mediator-util.js"></script>
<table class="normal" width="100%">
<tr>
    <td>
        <h2><fmt:message key="rule.mediator.header"/></h2>
    </td>
</tr>
<tr>
    <td>
        <table class="normal">
            <tr>
                <td><fmt:message key="mediator.rule.key"/> <font
                        style='color: red;font-size: 8pt;'>&#160;*</font>
                </td>
                <td>
                    <select id="mediator.rule.sourceformat"
                            name="mediator.rule.sourceformat">
                        <%
                            if (RuleConstants.SOURCE_FORMAT_NATIVE.equals(format)) {
                        %>
                        <option id="native" value="native" selected="true">Native</option>
                        <option id="xml" value="xml">XML</option>
                        <%
                        } else {
                        %>
                        <option id="xml" value="xml" selected="true">XML</option>
                        <option id="native" value="native">Native</option>
                        <%
                            }
                        %>
                    </select>
                </td>
                <td>
                     <select id="mediator.rule.inline"
                            name="mediator.rule.inline" onchange="onScriptSourceModeSelectionChange();">
                        <%
                            if (isInlined) {
                        %>
                        <option id="inline" value="inline" selected="true">In-lined</option>
                        <option id="registrykeylookup" value="registrykey">Registry Lookup</option>
                        <%
                        } else {
                        %>
                         <option id="registrykeylookup" value="registrykey" selected="true">Registry Lookup</option>
                         <option id="inline" value="inline">In-lined</option>
                        <%
                            }
                        %>
                    </select>
                </td>

                <td id="inline_rulescript" style="<%=!isInlined?"display:none" : ""%>"><a
                        href="#ruleScriptBrowserLink" class="policie-icon-link"
                        style="padding-left:40px"
                        onclick="showInLinedRuleScriptPolicyEditor('<%=policyID%>');"><fmt:message  key="ruleScript.policy.editor"/></a>
                </td>

                <td id="regkey_rulescript" style="<%=isInlined? "display:none;" : ""%>">
                    <input type="text" class="longInput" id="mediator.rule.key"
                           name="mediator.rule.key" value="<%=key%>"
                           disabled="true"/>
                    <input type="hidden" id="mediator.rule.key_hidden"
                           name="mediator.rule.key_hidden"
                           value="<%=key%>"/>
                </td>
                <td id="regbrowser_rulescript"  style="<%=isInlined? "display:none;" : ""%>">
                    <a href="#registryBrowserLink" class="registry-picker-icon-link"
                       style="padding-left:40px"
                       onclick="showInLinedRegistryBrowser('mediator.rule.key');"><fmt:message
                            key="registry.keys"/></a>
                </td>
            </tr>
            <tr>
                <td>
                    <a name="ruleScriptBrowserLink"></a>

                    <div id="ruleScriptBrowser" style="display:none;"></div>
                </td>
            </tr>
        </table>
    </td>
</tr>
<tr>
    <td><h3 class="mediator"><fmt:message key="mediator.rule.provider"/></h3></td>
</tr>
<tr>
    <td>
        <table class="normal">
            <tr>
                <td><fmt:message key="mediator.rule.provider.uri"/>
                </td>
                <td>
                    <input type="text" class="longInput" id="mediator.rule.provider.uri"
                           name="mediator.rule.provider.uri" value="<%=uri%>"/>
                </td>
            </tr>
            <tr>
                <td><fmt:message key="mediator.rule.provider.class"/>
                </td>
                <td>
                    <input type="text" class="longInput" id="mediator.rule.provider.class"
                           name="mediator.rule.provider.class" value="<%=providerClass%>"/>
                </td>
            </tr>
        </table>
    </td>
</tr>
<%=RuleMediatorClientHelper.getPropertyXML("provider", configuration != null ?
        configuration.getAllRuleExecutionSetProviderProperties() :
        new ArrayList<PropertyDescription>().iterator(), request.getLocale())%>
<tr>
    <td><h3 class="mediator"><fmt:message key="mediator.rule.rulesession"/></h3></td>
</tr>
<tr>
    <td>
        <table class="normal">
            <tr>
                <td><fmt:message key="mediator.rule.rulesession.type"/>
                </td>
                <td>
                    <select id="mediator.rule.rulesession"
                            name="mediator.rule.rulesession">
                        <%
                            if ("".equals(sessionString) ||
                                    RuleConstants.STATEFUL_RULE_SESSION.equals(sessionString)) {
                        %>
                        <option id="stateful" value="stateful" selected="true">Stateful</option>
                        <option id="stateless" value="stateless">Stateless</option>
                        <%
                        } else {
                        %>
                        <option id="stateless" value="stateless" selected="true">Stateless</option>
                        <option id="stateful" value="stateful">Stateful</option>
                        <%
                            }
                        %>
                    </select>
                </td>
            </tr>
        </table>
    </td>
</tr>
<%=RuleMediatorClientHelper.getPropertyXML("rulesession", configuration != null ?
        configuration.getAllRuleSessionProperties() :
        new ArrayList<PropertyDescription>().iterator(), request.getLocale())%>
<%=RuleMediatorClientHelper.getPropertyXML("creation", configuration != null ?
        configuration.getAllRuleExecutionSetCreationProperties() :
        new ArrayList<PropertyDescription>().iterator(), request.getLocale())%>
<%=RuleMediatorClientHelper.getPropertyXML("registration", configuration != null ?
        configuration.getAllRuleExecutionSetRegistrationProperties() :
        new ArrayList<PropertyDescription>().iterator(), request.getLocale())%>
<%=RuleMediatorClientHelper.getPropertyXML("deregistration", configuration != null ?
        configuration.getAllRuleExecutionSetDeregistrationProperties():
        new ArrayList<PropertyDescription>().iterator(), request.getLocale())%>
<tr>
<td>
<h3 class="mediator"><fmt:message key="mediator.rule.inputs"/></h3>

<div style="margin-top:10px;">
<table id="inputtable" style="<%=inputTableStyle%>" class="styledInner">
<thead>
<tr>
    <th><fmt:message key="th.parameter.type"/></th>
    <th><fmt:message key="th.parameter.name"/></th>
    <th><fmt:message key="th.value.type"/></th>
    <th><fmt:message key="th.value.expression"/></th>
    <th id="inputreg-key-th" style="display:none;"><fmt:message key="th.registry.key"/></th>
    <th id="inputreg-browser-th" style="display:none;"><fmt:message key="registry.browser"/></th>
    <th id="inputns-edior-th" style="display:none;"><fmt:message key="namespaceeditor"/></th>
    <th><fmt:message key="th.action"/></th>
</tr>
<tbody id="inputtbody">
<%
    int i = 0;
    while (inputs.hasNext()) {
        ResourceDescription input = inputs.next();
        if (input != null) {
            String name = input.getName();
            String value = "";
            boolean isLiteral = true;
            String regKey = "";
            BaseXPath expr = input.getExpression();
            if (expr != null) {
                nameSpacesRegistrar.registerNameSpaces((AXIOMXPath) expr,
                        "inputValue" + i, session);
                value = expr.toString();
                String inputRegKey = input.getKey();
                if (inputRegKey != null) {
                    regKey = inputRegKey;
                }
                isLiteral = false;
            } else {
                value = RuleMediatorClientHelper.getValue(input);
            }
            String type = RuleMediatorClientHelper.getType(input);
            if (name != null && !"".equals(name)) {

%>
<tr id="inputRaw<%=i%>">
<td>
    <select id="inputType<%=i%>" name="inputType<%=i%>">
        <% if (value == null) {%>
        <option value="Select-A-Value" selected="true"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("custom".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom" selected="true">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("sequence".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence" selected="true">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("omelement".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement" selected="true">omelement</option>
        <%} else if ("int".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int" selected="true">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("integer".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer" selected="true">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("byte".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte" selected="true">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("double".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double" selected="true">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("short".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short" selected="true">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("long".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long" selected="true">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("float".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float" selected="true">float</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <option value="string">string</option>
        <%} else if ("boolean".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean" selected="true">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("string".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string" selected="true">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%}%>
    </select>
</td>

<td><input type="text" name="inputName<%=i%>" id="inputName<%=i%>" value="<%=name%>"/></td>
<td>
    <select name="inputTypeSelection<%=i%>"
            id="inputTypeSelection<%=i%>"
            onchange="onResourceTypeSelectionChange('<%=i%>','input');">
        <% if (isLiteral) {%>
        <option value="literal" selected="true">
            <fmt:message key="value"/>
        </option>
        <option value="expression">
            <fmt:message key="expression"/>
        </option>
        <%} else { %>
        <option value="expression" selected="true">
            <fmt:message key="expression"/>
        </option>
        <option value="literal">
            <fmt:message key="value"/>
        </option>
        <% }%>
    </select>
</td>
<td>
    <input id="inputValue<%=i%>" name="inputValue<%=i%>" type="text" value="<%=value%>"/>
</td>
<td id="inputregistrykeyTD<%=i%>" style="<%=isLiteral? "display:none;" : ""%>">
    <% if (!isLiteral) {%>
    <input id="inputregistryKey<%=i%>" name="inputregistryKey<%=i%>" type="text" value="<%=regKey%>"
           disabled="true"/>
    <input id="inputregistryKey<%=i%>_hidden" name="inputregistryKey<%=i%>_hidden" type="hidden"
           value="<%=regKey%>"/>
    <% }%>
</td>
<td id="inputregistryBrowserButtonTD<%=i%>" style="<%=isLiteral? "display:none;" : ""%>">
    <% if (!isLiteral) {%>
    <a href="#registryBrowserLink" class="registry-picker-icon-link" style="padding-left:40px"
       onclick="showInLinedRegistryBrowser('registryKey<%=i%>');"><fmt:message
            key="registry.keys"/></a>
    <% }%>
</td>
<td id="inputnsEditorButtonTD<%=i%>" style="<%=isLiteral? "display:none;" : ""%>">
    <% if (!isLiteral) {%>
    <a href="#nsEditorLink" class="nseditor-icon-link"
       style="padding-left:40px"
       onclick="showNameSpaceEditor('inputValue<%=i%>');"><fmt:message key="namespaces"/></a>
    <% }%>
</td>

<td><a href="#" class="delete-icon-link" style="padding-left:40px"
       onclick="deleteresource('<%=i%>','input');"><fmt:message
        key="delete"/></a></td>
</tr>
<% }
}
    i++;
} %>
<input type="hidden" name="inputCount" id="inputCount" value="<%=i%>"/>
<script type="text/javascript">
    if (isRemainResourceExpressions("input")) {
        resetResourceDisplayStyle("","input");
    }
</script>
</tbody>
</thead>
</table>
</div>
</td>
</tr>
<tr>
    <td>
        <div style="margin-top:0px;">
            <a name="addinputLink"></a>
            <a class="add-icon-link"
               href="#addinputLink"
               onclick="addResource('input');"><fmt:message
                    key="mediator.rule.add.input"/></a>
        </div>
    </td>
</tr>
<tr>
<td>
<h3 class="mediator"><fmt:message key="mediator.rule.outputs"/></h3>

<div style="margin-top:10px;">
<table id="outputtable" style="<%=outputTableStyle%>" class="styledInner">
<thead>
<tr>
    <th><fmt:message key="th.parameter.type"/></th>
    <th><fmt:message key="th.parameter.name"/></th>
    <th><fmt:message key="th.value.type"/></th>
    <th><fmt:message key="th.value.expression"/></th>
    <th id="outputreg-key-th" style="display:none;"><fmt:message key="th.registry.key"/></th>
    <th id="outputreg-browser-th" style="display:none;"><fmt:message key="registry.browser"/></th>
    <th id="outputns-edior-th" style="display:none;"><fmt:message key="namespaceeditor"/></th>
    <th><fmt:message key="th.action"/></th>
</tr>
<tbody id="outputtbody">
<%
    int k = 0;
    while (outputs.hasNext()) {
        ResourceDescription output = outputs.next();
        if (output != null) {
            String name = output.getName();
            String value = "";
            boolean isLiteral = true;
            String regKey = "";
            BaseXPath expr = output.getExpression();
            if (expr != null) {
                nameSpacesRegistrar.registerNameSpaces((AXIOMXPath) expr,
                        "outputValue" + k, session);
                value = expr.toString();
                String outputRegKey = output.getKey();
                if (outputRegKey != null) {
                    regKey = outputRegKey;
                }
                isLiteral = false;
            } else {
                Object o = output.getValue();
                if (o != null) {
                    value = String.valueOf(o);
                }
            }
            String type = RuleMediatorClientHelper.getType(output);
            if (name != null && !"".equals(name)) {

%>
<tr id="outputRaw<%=k%>">
<td>
    <select id="outputType<%=k%>" name="outputType<%=k%>">
        <% if (value == null) {%>
        <option value="Select-A-Value" selected="true"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("custom".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom" selected="true">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("sequence".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence" selected="true">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("omelement".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement" selected="true">omelement</option>
        <%} else if ("int".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int" selected="true">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("integer".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer" selected="true">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("byte".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte" selected="true">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("double".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double" selected="true">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("short".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short" selected="true">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("long".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long" selected="true">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("float".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float" selected="true">float</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <option value="string">string</option>
        <%} else if ("boolean".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean" selected="true">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%} else if ("string".equals(type)) {%>
        <option value="Select-A-Value"><fmt:message key="leave.as.is"/></option>
        <option value="int">int</option>
        <option value="integer">integer</option>
        <option value="boolean">boolean</option>
        <option value="byte">byte</option>
        <option value="double">double</option>
        <option value="short">short</option>
        <option value="long">long</option>
        <option value="float">float</option>
        <option value="string" selected="true">string</option>
        <option value="custom">custom</option>
        <option value="sequence">sequence</option>
        <option value="omelement">omelement</option>
        <%}%>
    </select>
</td>

<td>
    <input type="text" name="outputName<%=k%>" id="outputName<%=k%>" value="<%=name%>"/>
</td>
<td>
    <select name="outputTypeSelection<%=k%>"
            id="outputTypeSelection<%=k%>"
            onchange="onResourceTypeSelectionChange('<%=k%>','output');">
        <% if (isLiteral) {%>
        <option value="literal" selected="true">
            <fmt:message key="value"/>
        </option>
        <option value="expression">
            <fmt:message key="expression"/>
        </option>
        <%} else { %>
        <option value="expression" selected="true">
            <fmt:message key="expression"/>
        </option>
        <option value="literal">
            <fmt:message key="value"/>
        </option>
        <% }%>
    </select>
</td>
<td>
    <input id="outputValue<%=k%>" name="outputValue<%=k%>" type="text" value="<%=value%>"/>
</td>
<td id="outputregistrykeyTD<%=k%>" style="<%=isLiteral? "display:none;" : ""%>">
    <% if (!isLiteral) {%>
    <input id="outputregistryKey<%=k%>" name="outputregistryKey<%=k%>" type="text" value="<%=regKey%>"
            disabled="true"/>
    <input id="outputregistryKey<%=k%>_hidden" name="outputregistryKey<%=k%>_hidden" type="hidden"
            value="<%=regKey%>"/>
    <% }%>
</td>
<td id="outputregistryBrowserButtonTD<%=k%>" style="<%=isLiteral? "display:none;" : ""%>">
    <% if (!isLiteral) {%>
    <a href="#registryBrowserLink" class="registry-picker-icon-link" style="padding-left:40px"
       onclick="showInLinedRegistryBrowser('registryKey<%=k%>');"><fmt:message
            key="registry.keys"/></a>
    <% }%>
</td>
<td id="outputnsEditorButtonTD<%=k%>" style="<%=isLiteral? "display:none;" : ""%>">
    <% if (!isLiteral) {%>
    <a href="#nsEditorLink" class="nseditor-icon-link"
       style="padding-left:40px"
       onclick="showNameSpaceEditor('outputValue<%=k%>');"><fmt:message key="namespaces"/></a>
    <% }%>
</td>

<td><a href="#" class="delete-icon-link" style="padding-left:40px"
       onclick="deleteresource('<%=k%>','output');"><fmt:message
        key="delete"/></a></td>
</tr>
<% }
}
    k++;
} %>
<input type="hidden" name="outputCount" id="outputCount" value="<%=k%>"/>
<script type="text/javascript">
    if (isRemainResourceExpressions("output")) {
        resetResourceDisplayStyle("","output");
    }
</script>

</tbody>
</thead>
</table>
</div>
</td>
</tr>
<tr>
    <td>
        <div style="margin-top:0px;">
            <a name="addoutputLink"></a>
            <a class="add-icon-link"
               href="#addoutputLink"
               onclick="addResource('output');"><fmt:message
                    key="mediator.rule.add.output"/></a>
        </div>
    </td>
</tr>
</table>

<a name="nsEditorLink"></a>

<div id="nsEditor" style="display:none;"></div>

<a name="registryBrowserLink"></a>

<div id="registryBrowser" style="display:none;"></div>
</div>
</fmt:bundle>
