function addproperty(prefix) {

    if (!isValidProperties(prefix)) {
        return false;
    }
    var propertyCount = document.getElementById(prefix + "propertyCount");
    var i = propertyCount.value;

    var currentCount = parseInt(i);
    currentCount = currentCount + 1;

    propertyCount.value = currentCount;

    var propertytable = document.getElementById(prefix + "propertytable");
    propertytable.style.display = "";
    var propertytbody = document.getElementById(prefix + "propertytbody");

    var propertyRaw = document.createElement("tr");
    propertyRaw.setAttribute("id", prefix + "propertyRaw" + i);

    var nameTD = document.createElement("td");
    nameTD.innerHTML = "<input type='text' name='" + prefix + "propertyName" + i + "' id='" + prefix + "propertyName" + i + "'" + " />";

    var valueTD = document.createElement("td");
    valueTD.innerHTML = "<input type='text' name='" + prefix + "propertyValue" + i + "' id='" + prefix + "propertyValue" + i + "'" + " />";

    var deleteTD = document.createElement("td");
    deleteTD.innerHTML = "<a href='#' class='delete-icon-link' style='padding-left:40px' onclick=\"deleteproperty('" + i + "','" + prefix + "')\" >" + rulejsi18n["mediator.rule.action.delete"] + "</a>";

    propertyRaw.appendChild(nameTD);
    propertyRaw.appendChild(valueTD);
    propertyRaw.appendChild(deleteTD);

    propertytbody.appendChild(propertyRaw);
    return true;
}

function isValidProperties(prefixId) {

    var nsCount = document.getElementById(prefixId + "Count");
    if (nsCount == null) {
        return true;
    }
    var i = nsCount.value;
    var currentCount = parseInt(i);

    if (currentCount >= 1) {
        for (var k = 0; k < currentCount; k++) {
            var prefix = document.getElementById(prefixId + "propertyName" + k);
            if (prefix != null && prefix != undefined) {
                if (prefix.value == "") {
                    CARBON.showWarningDialog(rulejsi18n["mediator.rule." + prefixId + ".name.empty"]);
                    return false;
                }
            }
            var uri = document.getElementById(prefixId + "propertyValue" + k);
            if (uri != null && uri != undefined) {
                if (uri.value == "") {
                    CARBON.showWarningDialog(rulejsi18n["mediator.rule." + prefixId + ".value.empty"]);
                    return false;
                }
            }
        }
    }
    return true;
}

function resetPropertyDisplayStyle(displayStyle, prefix) {
    document.getElementById(prefix + 'ns-edior-th').style.display = displayStyle;
    var nsCount = document.getElementById(prefix + "propertyCount");
    var i = nsCount.value;

    var currentCount = parseInt(i);

    if (currentCount >= 1) {
        for (var k = 0; k < currentCount; k++) {
            var nsEditorButtonTD = document.getElementById(prefix + "nsEditorButtonTD" + k);
            if (nsEditorButtonTD != undefined && nsEditorButtonTD != null) {
                nsEditorButtonTD.style.display = displayStyle;
            }
        }
    }
}

function deleteproperty(i, prefix) {
    var propRow = document.getElementById(prefix + "propertyRaw" + i);
    if (propRow != undefined && propRow != null) {
        var parentTBody = propRow.parentNode;
        if (parentTBody != undefined && parentTBody != null) {
            parentTBody.removeChild(propRow);
            if (!isContainRaw(parentTBody)) {
                var propertyTable = document.getElementById(prefix + "propertytable");
                propertyTable.style.display = "none";
            }
        }
    }
}

function isRemainPropertyExpressions(prefix) {
    var nsCount = document.getElementById(prefix + "propertyCount");
    var i = nsCount.value;

    var currentCount = parseInt(i);

    if (currentCount >= 1) {
        for (var k = 0; k < currentCount; k++) {
            var propertyType = getSelectedValue(prefix + 'propertyTypeSelection' + k);
            if ("expression" == propertyType) {
                return true;
            }
        }
    }
    return false;
}

function onPropertyTypeSelectionChange(i, prefix) {
    var propertyType = getSelectedValue(prefix + 'propertyTypeSelection' + i);
    if (propertyType != null) {
        settypeOfProperty(propertyType, i, prefix);
    }

}

function settypeOfProperty(type, i, prefix) {
    var nsEditorButtonTD = document.getElementById(prefix + "nsEditorButtonTD" + i);
    if (nsEditorButtonTD == null || nsEditorButtonTD == undefined) {
        return;
    }
    if ("expression" == type) {
        resetPropertyDisplayStyle("", prefix);
        nsEditorButtonTD.innerHTML = "<a href='#nsEditorLink' class='nseditor-icon-link' style='padding-left:40px' onclick=\"showNameSpaceEditor('" + prefix + "propertyValue" + i + "')\">" + rulejsi18n["namespaces"] + "</a>";
    } else {
        nsEditorButtonTD.innerHTML = "";
        if (!isRemainPropertyExpressions(prefix)) {
            resetPropertyDisplayStyle("none", prefix);
        }
    }
}
function createboolselectelement(id) {
    // Create the element:
    var combo_box = document.createElement('select');

    // Set some properties:
    combo_box.name = id;
    combo_box.setAttribute("id", id);

    // Add some choices:
    var choice = document.createElement('option');
    choice.value = 'true';
    choice.appendChild(document.createTextNode(rulejsi18n["mediator.rule.text.true"]));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'false';
    choice.appendChild(document.createTextNode(rulejsi18n["mediator.rule.text.false"]));
    combo_box.appendChild(choice);

    return combo_box;
}


function addResource(prefix) {

    if (!isValidResources(prefix)) {
        return false;
    }

    var displayStyleOfNSEditor = document.getElementById(prefix + 'ns-edior-th').style.display;
    var inputCount = document.getElementById(prefix + "Count");
    var i = inputCount.value;

    var currentCount = parseInt(i);
    currentCount = currentCount + 1;

    inputCount.value = currentCount;

    var inputtable = document.getElementById(prefix + "table");
    inputtable.style.display = "";
    var inputtbody = document.getElementById(prefix + "tbody");

    var inputRaw = document.createElement("tr");
    inputRaw.setAttribute("id", prefix + "Raw" + i);

    var inputType = document.createElement("td");
    inputType.innerHTML = "<select id='" + prefix + "Type" + i + "' name='" + prefix + "Type" + i + "' >" +
                          "<option value='Select-A-Value'>" + rulejsi18n["leave.as.is"] + "</option><option value='int'>" +
                          rulejsi18n["mediator.rule.type.int"] + "</option><option value='integer'>" +
                          rulejsi18n["mediator.rule.type.integer"] + "</option><option value='boolean'>" +
                          rulejsi18n["mediator.rule.type.boolean"] + "</option><option value='byte'>" +
                          rulejsi18n["mediator.rule.type.byte"] + "</option><option value='double'>" +
                          rulejsi18n["mediator.rule.type.double"] + "</option><option value='short'>" +
                          rulejsi18n["mediator.rule.type.short"] + "</option><option value='long'>" +
                          rulejsi18n["mediator.rule.type.long"] +
                          "</option><option value='float'>" + rulejsi18n["mediator.rule.type.float"] +
                          "</option><option value='string'>" + rulejsi18n["mediator.rule.type.string"] +
                          "</option><option value='omelement'>" + rulejsi18n["mediator.rule.type.omelement"] +
                          "</option><option value='sequence'>" +
                          rulejsi18n["mediator.rule.type.sequence"] + "</option><option value='custom'>" +
                          rulejsi18n["mediator.rule.type.custom"] + "</option></select>";
    var nameTD = document.createElement("td");
    nameTD.innerHTML = "<input type='text' name='" + prefix + "Name" + i + "' id='" + prefix + "Name" + i + "'" +
                       "></input>";

    var typeTD = document.createElement("td");
    typeTD.appendChild(createresourcetypecombobox(prefix + 'TypeSelection' + i, i, prefix));

    var valueTD = document.createElement("td");
    valueTD.innerHTML = "<input type='text' name='" + prefix + "Value" + i + "' id='" + prefix + "Value" + i + "'" +
                        "></input>";
    var regKeyTD = document.createElement("td");
    regKeyTD.style.display = displayStyleOfNSEditor;
    regKeyTD.setAttribute("id", prefix + "registrykeyTD" + i);

    regKeyTD.innerHTML = "<input id='" + prefix + "registryKey" + i + "' name='" + prefix + "registryKey" + i + "' type='text' disabled='true'></input>" +
                         "<input id='" + prefix + "registryKey" + i + "_hidden' name='" + prefix + "registryKey" + i + "_hidden' type='hidden'></input>";

    var regBrowserTD = document.createElement("td");
    regBrowserTD.style.display = displayStyleOfNSEditor;
    regBrowserTD.setAttribute("id", prefix + "registryBrowserButtonTD" + i);
    regBrowserTD.innerHTML = "<a href='#registryBrowserLink' class='registry-picker-icon-link' style='padding-left:40px' onclick=\"showInLinedRegistryBrowser('" + prefix + "registryKey" + i + "')\">" + rulejsi18n["registry.keys"] + "</a>";

    var nsTD = document.createElement("td");
    nsTD.style.display = displayStyleOfNSEditor;

    nsTD.setAttribute("id", prefix + "nsEditorButtonTD" + i);
    var deleteTD = document.createElement("td");
    deleteTD.innerHTML = "<a href='#' class='delete-icon-link' style='padding-left:40px' onclick=\"deleteresource('" + i + "','" + prefix + "')\" >" + rulejsi18n["mediator.rule.action.delete"] + "</a>";

    inputRaw.appendChild(inputType);
    inputRaw.appendChild(nameTD);
    inputRaw.appendChild(typeTD);
    inputRaw.appendChild(valueTD);
    inputRaw.appendChild(regKeyTD);
    inputRaw.appendChild(regBrowserTD);
    inputRaw.appendChild(nsTD);
    inputRaw.appendChild(deleteTD);
    inputtbody.appendChild(inputRaw);
    return true;
}

function isValidResources(prefixId) {

    var nsCount = document.getElementById(prefixId + "Count");
    if (nsCount == null) {
        return true;
    }
    var i = nsCount.value;
    var currentCount = parseInt(i);

    if (currentCount >= 1) {
        for (var k = 0; k < currentCount; k++) {
            var prefix = document.getElementById(prefixId + "Name" + k);
            if (prefix != null && prefix != undefined) {
                if (prefix.value == "") {
                    CARBON.showWarningDialog(rulejsi18n["mediator.rule." + prefixId + ".name.empty"]);
                    return false;
                }
            }
            var typeSelection = document.getElementById(prefixId + "TypeSelection" + k);
            if (typeSelection != null && typeSelection.value == "literal") {
                var uri = document.getElementById(prefixId + "Value" + k);
                if (uri != null && uri != undefined) {
                    if (uri.value == "") {
                        CARBON.showWarningDialog(rulejsi18n["mediator.rule." + prefixId + ".value.empty"]);
                        return false;
                    }
                }
            }

            var type = getSelectedValue(prefixId + "Type" + k);
            if (type == 'Select-A-Value') {
                CARBON.showWarningDialog(rulejsi18n["mediator.rule." + prefixId + ".type.empty"]);
                return false;
            }
        }
    }
    return true;
}

function resetResourceDisplayStyle(displayStyle, prefix) {
    document.getElementById(prefix + 'ns-edior-th').style.display = displayStyle;
    document.getElementById(prefix + 'reg-key-th').style.display = displayStyle;
    document.getElementById(prefix + 'reg-browser-th').style.display = displayStyle;
    var nsCount = document.getElementById(prefix + "Count");
    var i = nsCount.value;

    var currentCount = parseInt(i);

    if (currentCount >= 1) {
        for (var k = 0; k < currentCount; k++) {
            var nsEditorButtonTD = document.getElementById(prefix + "nsEditorButtonTD" + k);
            if (nsEditorButtonTD != undefined && nsEditorButtonTD != null) {
                nsEditorButtonTD.style.display = displayStyle;
            }
            var registryBrowserButtonTD = document.getElementById(prefix + "registryBrowserButtonTD" + k);
            if (registryBrowserButtonTD != undefined && registryBrowserButtonTD != null) {
                registryBrowserButtonTD.style.display = displayStyle;
            }
            var registrykeyTD = document.getElementById(prefix + "registrykeyTD" + k);
            if (registrykeyTD != undefined && registrykeyTD != null) {
                registrykeyTD.style.display = displayStyle;
            }
        }
    }
}
function createresourcetypecombobox(id, i, prefix) {
    // Create the element:
    var combo_box = document.createElement('select');

    // Set some properties:
    combo_box.name = id;
    combo_box.setAttribute("id", id);
    combo_box.onchange = function () {
        onResourceTypeSelectionChange(i, prefix);
    };
    // Add some choices:
    var choice = document.createElement('option');
    choice.value = 'literal';
    choice.appendChild(document.createTextNode('Value'));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'expression';
    choice.appendChild(document.createTextNode('Expression'));
    combo_box.appendChild(choice);

    return combo_box;
}
function createproperttypecombobox(id, i, prefix) {
    // Create the element:
    var combo_box = document.createElement('select');

    // Set some properties:
    combo_box.name = id;
    combo_box.setAttribute("id", id);
    combo_box.onchange = function () {
        onPropertyTypeSelectionChange(i, prefix);
    };
    // Add some choices:
    var choice = document.createElement('option');
    choice.value = 'literal';
    choice.appendChild(document.createTextNode('Value'));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'expression';
    choice.appendChild(document.createTextNode('Expression'));
    combo_box.appendChild(choice);

    return combo_box;
}

function deleteresource(i, prefix) {
    var propRow = document.getElementById(prefix + "Raw" + i);
    if (propRow != undefined && propRow != null) {
        var parentTBody = propRow.parentNode;
        if (parentTBody != undefined && parentTBody != null) {
            parentTBody.removeChild(propRow);
            if (!isContainRaw(parentTBody)) {
                var inputTable = document.getElementById(prefix + "table");
                inputTable.style.display = "none";
            }
            if (!isRemainResourceExpressions(prefix)) {
                resetResourceDisplayStyle("none", prefix);
            }
        }
    }
}

function isRemainResourceExpressions(prefix) {
    var nsCount = document.getElementById(prefix + "Count");
    var i = nsCount.value;

    var currentCount = parseInt(i);

    if (currentCount >= 1) {
        for (var k = 0; k < currentCount; k++) {
            var inputType = getSelectedValue(prefix + 'TypeSelection' + k);
            if ("expression" == inputType) {
                return true;
            }
        }
    }
    return false;
}

function onResourceTypeSelectionChange(i, prefix) {
    var inputType = getSelectedValue(prefix + 'TypeSelection' + i);
    if (inputType != null) {
        settype(inputType, i, prefix);
    }
}
function onScriptSourceModeSelectionChange() {
    var sourceMode = getSelectedValue("mediator.rule.inline");
    if (sourceMode != null) {
        var scriptEditorButtonTD = document.getElementById("inline_rulescript");
        var regKeyTD = document.getElementById("regkey_rulescript");
        var regBrowserTD = document.getElementById("regbrowser_rulescript");
        if (scriptEditorButtonTD == undefined || scriptEditorButtonTD == null ||
            regKeyTD == undefined || regKeyTD == null ||
            regBrowserTD == undefined || regBrowserTD == null) {
            return;
        }
        if (sourceMode == "inline") {
            regKeyTD.style.display = "none";
            regBrowserTD.style.display = "none";
            scriptEditorButtonTD.style.display = "";
        } else {
            regKeyTD.style.display = "";
            regBrowserTD.style.display = "";
            scriptEditorButtonTD.style.display = "none";
        }
    }
}
function showInLinedRuleScriptPolicyEditor(id) {

    if (id == null || id == undefined || id == "") {
        CARBON.showInfoDialog("ID cannot be null or empty");
    }
    var loadingContent = "<div id='workArea'><div id='popupContent'><div class='ajax-loading-message'> <img src='../resources/images/ajax-loader.gif' align='top'/> <span>Rule Script Policy Editor loading please wait ..</span> </div></div></div>";
    CARBON.showPopupDialog(loadingContent, rulejsi18n["rule.policy.editor"], 500, false, null, 900);
    var random = Math.floor(Math.random() * 2000);
    var url = '../rule-mediator/rulesript_editor-ajaxprocessor.jsp?scriptID=' + id ;
    jQuery("#popupContent").load(url, null,
            function(res, status, t) {
                if (status != "success") {
                    CARBON.showWarningDialog(rulejsi18n["rule.policy.error"]);
                }
            });
    return false;
}

function saveRuleScript(id) {
    var scriptxml = document.getElementById("inlined_rule_script_source").value;
    if (scriptxml == null) {
        scriptxml = "";
    }
    var url = '../rule-mediator/rulescript_save-ajaxprocessor.jsp?scriptID=' + id ;
    jQuery.post(url, ({scriptxml:scriptxml}),
            function(data, status) {
                if (status != "success") {
                    CARBON.showWarningDialog(rulejsi18n["rule.policy.error"]);
                }
            });
    CARBON.closeWindow();
    return false;
}
function createinputtextbox(id, value) {

    var input = document.createElement('input');
    input.setAttribute('id', id);
    input.name = id;
    input.setAttribute('type', 'text');
    if (value != null && value != undefined) {
        input.setAttribute('value', value);
    }

    return input;
}

function settype(type, i, prefix) {
    var nsEditorButtonTD = document.getElementById(prefix + "nsEditorButtonTD" + i);
    var regKeyTD = document.getElementById(prefix + "registrykeyTD" + i);
    var regBrowserTD = document.getElementById(prefix + "registryBrowserButtonTD" + i);
    if (nsEditorButtonTD == undefined || nsEditorButtonTD == null || regKeyTD == undefined
            || regKeyTD == null || regBrowserTD == undefined || regBrowserTD == null) {
        return;
    }
    if ("expression" == type) {
        resetResourceDisplayStyle("", prefix);
        regBrowserTD.innerHTML = "<a href='#registryBrowserLink' class='registry-picker-icon-link' " +
                                 "style='padding-left:40px' onclick=\"showInLinedRegistryBrowser('registryKey" + i + "')\">" + rulejsi18n["registry.keys"] + "</a>";
        regKeyTD.innerHTML = "<input id='registryKey" + i + "' name='registryKey" + i + "' type='text' disabled='true' />" +
                             "<input id='registryKey" + i + "_hidden' name='registryKey" + i + "_hidden' type='hidden'  />";
        nsEditorButtonTD.innerHTML = "<a href='#nsEditorLink' class='nseditor-icon-link' " +
                                     "style='padding-left:40px' onclick=\"showNameSpaceEditor('" + prefix + "Value" + i + "')\">" + rulejsi18n["namespaces"] + "</a>";
    } else {
        nsEditorButtonTD.innerHTML = "";
        regBrowserTD.innerHTML = "";
        regKeyTD.innerHTML = "";
        if (!isRemainResourceExpressions(prefix)) {
            resetResourceDisplayStyle("none", prefix);
        }
    }
}
function isContainRaw(tbody) {
    if (tbody.childNodes == null || tbody.childNodes.length == 0) {
        return false;
    } else {
        for (var i = 0; i < tbody.childNodes.length; i++) {
            var child = tbody.childNodes[i];
            if (child != undefined && child != null) {
                if (child.nodeName == "tr" || child.nodeName == "TR") {
                    return true;
                }
            }
        }
    }
    return false;
}

function ruleMediatorValidate() {
    var sourceMode = getSelectedValue("mediator.rule.inline");
    if (sourceMode != "inline") {
        var key = document.getElementById("mediator.rule.key");
        if (key == null || key == undefined || key.value == undefined || key.value == "") {
            CARBON.showWarningDialog(rulejsi18n["mediator.rule.script.key.empty"]);
            return false;
        }
    }
    if (isValidResources("input")) {
        return isValidResources("output");
    } else {
        return false;
    }
}

function getSelectedValue(id) {
    var inputType = document.getElementById(id);
    var inputType_indexstr = null;
    var inputType_value = null;
    if (inputType != null) {
        inputType_indexstr = inputType.selectedIndex;
        if (inputType_indexstr != null) {
            inputType_value = inputType.options[inputType_indexstr].value;
        }
    }
    return inputType_value;
}
